package gregapi;

import static gregapi.data.CS.GAPI_POST;
import static gregapi.data.CS.T;
import static gregapi.data.CS.W;
import gregapi.api.Abstract_Mod;
import gregapi.api.Abstract_Proxy;
import gregapi.data.CS.ModIDs;
import gregapi.data.CS.ModNames;
import gregapi.data.CS.PlankData;
import gregapi.data.*;
import gregapi.load.LoaderItemData;
import gregapi.load.LoaderItemList;
import gregapi.oredict.OreDictManager;
import gregapi.util.OM;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.event.*;

/**
 * @author Gregorius Techneticies
 * 
 * This loads after the compatible Mods. The regular API loads before the compatible Mods.
 */
@Mod(modid=ModIDs.GAPI_POST, name=ModNames.GAPI_POST, version="GT6-MC1710", dependencies="required-after:"+ModIDs.GAPI+"; after:"+ModIDs.IC2+"; after:"+ModIDs.NC+"; after:"+ModIDs.FMB+"; after:"+ModIDs.CrGu+"; after:"+ModIDs.CC+"; after:"+ModIDs.OC+"; after:"+ModIDs.FR+"; after:"+ModIDs.IE+"; after:"+ModIDs.UB+"; after:"+ModIDs.PFAA+"; after:"+ModIDs.TC+"; after:"+ModIDs.TCFM+"; after:"+ModIDs.BOTA+"; after:"+ModIDs.WTCH+"; after:"+ModIDs.HOWL+"; after:"+ModIDs.MoCr+"; after:"+ModIDs.RC+"; after:"+ModIDs.AE+"; after:"+ModIDs.TE_CORE+"; after:"+ModIDs.TE+"; after:"+ModIDs.CHSL+"; after:"+ModIDs.BbLC+"; after:"+ModIDs.TF+"; after:"+ModIDs.MFR+"; after:"+ModIDs.ExU+"; after:"+ModIDs.HaC+"; after:"+ModIDs.APC+"; after:"+ModIDs.ENVM+"; after:"+ModIDs.MaCr+"; after:"+ModIDs.BC_TRANSPORT+"; after:"+ModIDs.BC_SILICON+"; after:"+ModIDs.BC_FACTORY+"; after:"+ModIDs.BC_ENERGY+"; after:"+ModIDs.BC_ROBOTICS+"; after:"+ModIDs.BC_CORE+"; after:"+ModIDs.BC_BUILDERS+"; after:"+ModIDs.MgC+"; after:"+ModIDs.DRGN+"; after:"+ModIDs.ElC+"; after:"+ModIDs.ReC+"; after:"+ModIDs.RoC+"; after:"+ModIDs.GC_CORE+"; after:"+ModIDs.GC_MARS+"; after:"+ModIDs.GC_PLANETS+"; after:"+ModIDs.ATUM+"; after:"+ModIDs.EBXL+"; after:"+ModIDs.BoP+"; after:"+ModIDs.ATG+"; after:"+ModIDs.FZ+"; after:"+ModIDs.MNTL+"; after:"+ModIDs.TiC+"; after:ThermalExpansion|Transport; after:ThermalExpansion|Energy; after:ThermalExpansion|Factory; after:RedPowerCore; after:RedPowerBase; after:RedPowerMachine; after:RedPowerCompat; after:RedPowerWiring; after:RedPowerLogic; after:RedPowerLighting; after:RedPowerWorld; after:RedPowerControl;" /*after:ProjRed; after:ProjRed|Exploration; after:NetherOres; after:factorization; after:XyCraft; after:MetallurgyCore; after:MetallurgyBase; after:MetallurgyEnder; after:MetallurgyFantasy; after:MetallurgyNether; after:MetallurgyPrecious; after:MetallurgyUtility; before:TConstruct; before:TConstruct-Preloader; before:TMechworks; after:Tubestuff; after:ICBM; after:Mekanism; after:MekanismGenerators; after:MekanismTools; after:ThaumicTinkerer; after:LiquidXP; after:factorization.misc; after:AtomicScience; after:MFFS; after:ICBM|Contraption; after:ICBM|Explosion; after:ICBM|Sentry; after:mmmPowersuits;*/)
public class GT_API_Post extends Abstract_Mod {
	public GT_API_Post() {GAPI_POST = this;}
	
	@Override public String getModID() {return ModIDs.GAPI_POST;}
	@Override public String getModName() {return ModNames.GAPI_POST;}
	@Override public String getModNameForLog() {return "GT_API_POST";}
	@Override public Abstract_Proxy getProxy() {return null;}
	
	@Mod.EventHandler public final void onPreLoad			(FMLPreInitializationEvent	aEvent) {GT_API.sAllowCrossModItemAccess = T; onModPreInit(aEvent);}
	@Mod.EventHandler public final void onLoad				(FMLInitializationEvent		aEvent) {onModInit(aEvent);}
	@Mod.EventHandler public final void onPostLoad			(FMLPostInitializationEvent	aEvent) {onModPostInit(aEvent);}
	@Mod.EventHandler public final void onServerStarting	(FMLServerStartingEvent		aEvent) {onModServerStarting(aEvent);}
	@Mod.EventHandler public final void onServerStarted		(FMLServerStartedEvent		aEvent) {onModServerStarted(aEvent);}
	@Mod.EventHandler public final void onServerStopping	(FMLServerStoppingEvent		aEvent) {onModServerStopping(aEvent);}
	@Mod.EventHandler public final void onServerStopped		(FMLServerStoppedEvent		aEvent) {onModServerStopped(aEvent);}
	
	@Override
	public void onModPreInit2(FMLPreInitializationEvent aEvent) {
		new LoaderItemList().run();
		new LoaderItemData().run();
		
		// Because most of those Mods (and vanilla MC) are not OreDict Compatible and need to be set as Target manually.
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Manasteel			, UT.Stacks.make(ModIDs.TCFM, "FMResource", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.ElvenElementium	, UT.Stacks.make(ModIDs.TCFM, "FMResource", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.FierySteel			, UT.Stacks.make(ModIDs.TF, "item.fieryIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Knightmetal		, UT.Stacks.make(ModIDs.TF, "item.knightMetal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Steeleaf			, UT.Stacks.make(ModIDs.TF, "item.steeleafIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.IronWood			, UT.Stacks.make(ModIDs.TF, "item.ironwoodIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedAir			, UT.Stacks.make(ModIDs.TC, "ItemShard", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedFire		, UT.Stacks.make(ModIDs.TC, "ItemShard", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedWater		, UT.Stacks.make(ModIDs.TC, "ItemShard", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEarth		, UT.Stacks.make(ModIDs.TC, "ItemShard", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedOrder		, UT.Stacks.make(ModIDs.TC, "ItemShard", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEntropy		, UT.Stacks.make(ModIDs.TC, "ItemShard", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Hg					, UT.Stacks.make(ModIDs.TC, "ItemNugget", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Thaumium			, UT.Stacks.make(ModIDs.TC, "ItemNugget", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.VoidMetal			, UT.Stacks.make(ModIDs.TC, "ItemNugget", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Thaumium			, UT.Stacks.make(ModIDs.TC, "ItemResource", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.VoidMetal			, UT.Stacks.make(ModIDs.TC, "ItemResource", 1,16));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Hg					, UT.Stacks.make(ModIDs.TC, "ItemResource", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Amber				, UT.Stacks.make(ModIDs.TC, "ItemResource", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.blockSolid		, MT.Obsidian			, UT.Stacks.make(ModIDs.TC, "blockCosmeticSolid", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockSolid		, MT.Obsidian			, UT.Stacks.make(ModIDs.TC, "blockCosmeticSolid", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Thaumium			, UT.Stacks.make(ModIDs.TC, "blockCosmeticSolid", 1, 4));
//		OreDictManager.INSTANCE.setTarget(OP.dustTiny		, MT.Ag					, UT.Stacks.make(ModIDs.WTCH, "ingredient", 1, 157)); may be unbalanced
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Firestone			, UT.Stacks.make(ModIDs.RC, "firestone.raw", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.CoalCoke			, UT.Stacks.make(ModIDs.RC, "fuel.coke", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.CoalCoke			, UT.Stacks.make(ModIDs.RC, "cube", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Fe					, UT.Stacks.make(ModIDs.RC, "part.plate", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Steel				, UT.Stacks.make(ModIDs.RC, "part.plate", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.TinAlloy			, UT.Stacks.make(ModIDs.RC, "part.plate", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Cu					, UT.Stacks.make(ModIDs.RC, "part.plate", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Pb					, UT.Stacks.make(ModIDs.RC, "part.plate", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.NetherQuartz		, UT.Stacks.make(ModIDs.IE, "metal", 1, 18));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.ChargedCertusQuartz, UT.Stacks.make(ModIDs.AE, "item.ItemMultiMaterial", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Stone				, UT.Stacks.make(ModIDs.FMB, "stoneRod", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.TungstenCarbide	, UT.Stacks.make(ModIDs.MgC, "item.ingotCarbide", 1, 0));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.HydrogenFluoride	, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 0));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.UraniumEnriched	, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 1));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.UraniumDepleted	, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 2));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Ammonium			, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 3));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Quicklime			, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Calcite			, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.OREMATS.Magnetite	, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Th					, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Emerald			, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_raw", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Cd_In_Ag_Alloy		, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_crafting", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.SteelMagnetic		, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_crafting", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.SteelMagnetic		, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_crafting", 1,10));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.U_238				, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_crafting", 1,14));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.TungstenCarbide	, UT.Stacks.make(ModIDs.ReC, "reactorcraft_item_crafting", 1,17));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Netherrack			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 0));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Tar				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 1));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.SludgeOrganic		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 2)); smelts into ethanol
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.Wood				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Bedrock			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Salt				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 5));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.AmmoniumNitrate	, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 6)); Salt + Coal + Gunpowder + Redstone = 4 (180, 150, 200)
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.SilverIodide		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 7));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Al					, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 8)); No Target needed
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.Wheat				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Coal				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1,10));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.DryIce				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1,11));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.InductiveAlloy		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1,12));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Si					, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_powders", 1,14));
//		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Ethanol			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_ethanol", 1, 0)); burns for 400 furnace time
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Anthracite			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Prismane			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lonsdaleite		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Bedrock_HSLA_Alloy	, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.W					, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.InductiveAlloy		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.CoalCoke			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.SpringSteel		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Si					, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1,10));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.AluminiumAlloy		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_compacts", 1,11));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.HSLA				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_shaftcraft", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.HSLA				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_shaftcraft", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.HSLA				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_shaftcraft", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.HSLA				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_block_deco", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Anthracite			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_block_deco", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Lonsdaleite		, UT.Stacks.make(ModIDs.RoC, "rotarycraft_block_deco", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Bedrock_HSLA_Alloy	, UT.Stacks.make(ModIDs.RoC, "rotarycraft_block_deco", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.CoalCoke			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_block_deco", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Stone				, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_borecraft", 1, 13));
		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Diamond			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_borecraft", 1, 14));
//		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Livingwood			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_modinterface", 1, 17));
//		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Livingrock			, UT.Stacks.make(ModIDs.RoC, "rotarycraft_item_modinterface", 1, 18));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Nutmeg				, UT.Stacks.make(ModIDs.HaC, "groundnutmegItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cinnamon			, UT.Stacks.make(ModIDs.HaC, "groundcinnamonItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cocoa				, UT.Stacks.make(ModIDs.HaC, "cocoapowderItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Curry				, UT.Stacks.make(ModIDs.HaC, "currypowderItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxPlant			, UT.Stacks.make(ModIDs.HaC, "waxItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxBee				, UT.Stacks.make(ModIDs.HaC, "beeswaxItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxBee				, UT.Stacks.make(ModIDs.FR, "beeswax", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxRefractory		, UT.Stacks.make(ModIDs.FR, "refractoryWax", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Peat				, UT.Stacks.make(ModIDs.FR, "peat", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingotDouble	, MT.PeatBituminous		, UT.Stacks.make(ModIDs.FR, "bituminousPeat", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Pyrotheum			, UT.Stacks.make(ModIDs.TE_CORE, "material", 1, 512));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cryotheum			, UT.Stacks.make(ModIDs.TE_CORE, "material", 1, 513));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lignite			, UT.Stacks.make(ModIDs.UB, "ligniteCoal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.SulfuricAcid		, UT.Stacks.make(ModIDs.FZ, "acid", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.UNUSED.AquaRegia	, UT.Stacks.make(ModIDs.FZ, "acid", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Coffee				, UT.Stacks.makeIC2("coffeePowder", 1));
		OreDictManager.INSTANCE.setTarget(OP.cell			, MT.UUMatter			, UT.Stacks.makeIC2("uuMatterCell", 1));
		OreDictManager.INSTANCE.setTarget(OP.cell			, MT.ConstructionFoam	, UT.Stacks.makeIC2("CFCell", 1));
		OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Creosote			, UT.Stacks.make(ModIDs.RC, "fluid.creosote.cell", 1));
		OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Empty				, UT.Stacks.make(Items.bucket, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Water				, UT.Stacks.make(Items.water_bucket, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Lava				, UT.Stacks.make(Items.lava_bucket, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Milk				, UT.Stacks.make(Items.milk_bucket, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Empty				, UT.Stacks.make(Items.glass_bottle, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Water				, UT.Stacks.make(Items.potionitem, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Coal				, UT.Stacks.make(Blocks.coal_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Fe					, UT.Stacks.make(Blocks.iron_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Lapis				, UT.Stacks.make(Blocks.lapis_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone			, UT.Stacks.make(Blocks.redstone_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone			, UT.Stacks.make(Blocks.lit_redstone_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Au					, UT.Stacks.make(Blocks.gold_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Diamond			, UT.Stacks.make(Blocks.diamond_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Emerald			, UT.Stacks.make(Blocks.emerald_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.NetherQuartz		, UT.Stacks.make(Blocks.quartz_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lapis				, UT.Stacks.make(Items.dye, 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderEye			, UT.Stacks.make(Items.ender_eye, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderPearl			, UT.Stacks.make(Items.ender_pearl, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Diamond			, UT.Stacks.make(Items.diamond, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Emerald			, UT.Stacks.make(Items.emerald, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Coal				, UT.Stacks.make(Items.coal, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Charcoal			, UT.Stacks.make(Items.coal, 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherQuartz		, UT.Stacks.make(Items.quartz, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherStar			, UT.Stacks.make(Items.nether_star, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Au					, UT.Stacks.make(Items.gold_nugget, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Au					, UT.Stacks.make(Items.gold_ingot, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Fe					, UT.Stacks.make(Items.iron_ingot, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Paper				, UT.Stacks.make(Items.paper, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Sugar				, UT.Stacks.make(Items.sugar, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Bone				, UT.Stacks.make(Items.dye, 1, 15));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Redstone			, UT.Stacks.make(Items.redstone, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Gunpowder			, UT.Stacks.make(Items.gunpowder, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Glowstone			, UT.Stacks.make(Items.glowstone_dust, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Blaze				, UT.Stacks.make(Items.blaze_powder, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Blaze				, UT.Stacks.make(Items.blaze_rod, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Wood				, UT.Stacks.make(Items.stick, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Fe					, UT.Stacks.make(Blocks.iron_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Au					, UT.Stacks.make(Blocks.gold_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Diamond			, UT.Stacks.make(Blocks.diamond_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Emerald			, UT.Stacks.make(Blocks.emerald_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Lapis				, UT.Stacks.make(Blocks.lapis_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Coal				, UT.Stacks.make(Blocks.coal_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockDust		, MT.Redstone			, UT.Stacks.make(Blocks.redstone_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Fe					, UT.Stacks.makeIC2("casingiron", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Au					, UT.Stacks.makeIC2("casinggold", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Cu					, UT.Stacks.makeIC2("casingcopper", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Sn					, UT.Stacks.makeIC2("casingtin", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Pb					, UT.Stacks.makeIC2("casinglead", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Bronze				, UT.Stacks.makeIC2("casingbronze", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Steel				, UT.Stacks.makeIC2("casingadviron", 1));
		
		OM.blacklist(UT.Stacks.make(ModIDs.TC, "ItemResource", 1,18));
		
		// Initialising the List of Decorative Planks
		Block
		tBlock = Blocks.planks;
		for (int i = 0; i <  6; i++) PlankData.PLANKS[   i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.FR, "planks");
		for (int i = 0; i < 29; i++) PlankData.PLANKS[ 8+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.IE, "treatedWood");
		for (int i = 0; i <  3; i++) PlankData.PLANKS[40+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.TCFM, "TaintPlank");
		for (int i = 0; i <  1; i++) PlankData.PLANKS[43+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.MoCr, "MoCWoodPlank");
		for (int i = 0; i <  2; i++) PlankData.PLANKS[44+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.TC, "blockWoodenDevice");
		for (int i = 0; i <  2; i++) PlankData.PLANKS[46+i] = UT.Stacks.make(tBlock, 1, i+6);
		tBlock = UT.Stacks.block(ModIDs.BOTA, "livingwood");
		for (int i = 0; i <  6; i++) PlankData.PLANKS[48+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.BOTA, "dreamwood");
		for (int i = 0; i <  6; i++) PlankData.PLANKS[56+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.BOTA, "shimmerwoodPlanks");
		for (int i = 0; i <  1; i++) PlankData.PLANKS[64+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.WTCH, "witchwood");
		for (int i = 0; i <  3; i++) PlankData.PLANKS[65+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.TF, "tile.TFTowerStone");
		for (int i = 0; i <  4; i++) PlankData.PLANKS[68+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.BoP, "planks");
		for (int i = 0; i < 15; i++) PlankData.PLANKS[72+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.EBXL, "planks");
		for (int i = 0; i <  9; i++) PlankData.PLANKS[87+i] = UT.Stacks.make(tBlock, 1, i);
		tBlock = UT.Stacks.block(ModIDs.RC, "cube");
		for (int i = 0; i <  1; i++) PlankData.PLANKS[96+i] = UT.Stacks.make(tBlock, 1, 8);
	}
	
	@Override
	public void onModInit2(FMLInitializationEvent aEvent) {
		// Atum violates the "Items have to be created in preInit" Rule...
		OM.reg("cropDate"				, UT.Stacks.make(ModIDs.ATUM, "item.date", 1, 0));
		OM.reg("cropFlax"				, UT.Stacks.make(ModIDs.ATUM, "item.flax", 1, 0));
		OM.reg("seedFlax"				, UT.Stacks.make(ModIDs.ATUM, "item.flaxSeeds", 1, 0));
    	OM.reg("itemPelt"				, UT.Stacks.make(ModIDs.ATUM, "item.wolfPelt", 1, 0));
		OM.reg(OP.stone, MT.Limestone	, UT.Stacks.make(ModIDs.ATUM, "tile.stone", 1, W));
		OM.reg(OP.stone, MT.Limestone	, UT.Stacks.make(ModIDs.ATUM, "tile.cobble", 1, W));
	}
	
	@Override public void onModPostInit2(FMLPostInitializationEvent aEvent) {/**/}
	@Override public void onModServerStarting2(FMLServerStartingEvent aEvent) {/**/}
	@Override public void onModServerStarted2(FMLServerStartedEvent aEvent) {/**/}
	@Override public void onModServerStopping2(FMLServerStoppingEvent aEvent) {/**/}
	@Override public void onModServerStopped2(FMLServerStoppedEvent aEvent) {/**/}
}