package gregapi.code;

import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 */
public class ItemStackContainer {
	public final Item mItem;
	public final byte mStackSize;
	public final short mMetaData;
	
	public ItemStackContainer(Item aItem, long aStackSize, long aMetaData) {
		mItem = aItem;
		mStackSize = (byte)aStackSize;
		mMetaData = (short)aMetaData;
	}
	
	public ItemStackContainer(Block aBlock, long aStackSize, long aMetaData) {
		mItem = Item.getItemFromBlock(aBlock);
		mStackSize = (byte)aStackSize;
		mMetaData = (short)aMetaData;
	}
	
	public ItemStackContainer(long aID, long aStackSize, long aMetaData) {
		mItem = Item.getItemById((int)aID);
		mStackSize = (byte)aStackSize;
		mMetaData = (short)aMetaData;
	}
	
	public ItemStackContainer(ItemStack aStack) {
		this(aStack==null?null:aStack.getItem(), aStack==null?0:aStack.stackSize, aStack==null?0:UT.Stacks.meta(aStack));
	}
	
	public ItemStackContainer(ItemStack aStack, long aMetaData) {
		this(aStack==null?null:aStack.getItem(), aStack==null?0:aStack.stackSize, aStack==null?0:aMetaData);
	}
	
	public ItemStackContainer(int aHashCode) {
		this(UT.Stacks.toStack(aHashCode));
	}
	
	public ItemStack toStack() {
		if (mItem == null) return null;
		return UT.Stacks.make(mItem, 1, mMetaData);
	}
	
	public boolean isStackEqual(ItemStack aStack) {
		return UT.Stacks.equal(toStack(), aStack);
	}
	
	public boolean isStackEqual(ItemStackContainer aStack) {
		return UT.Stacks.equal(toStack(), aStack.toStack());
	}
	
	@Override
	public boolean equals(Object aStack) {
		if (aStack == this) return true;
		if (aStack instanceof ItemStackContainer) return ((ItemStackContainer)aStack).mItem == mItem && ((ItemStackContainer)aStack).mMetaData == mMetaData;
		return false;
	}
	
	@Override
	public int hashCode() {
		return UT.Stacks.toInt(toStack());
	}
}